rbenv:即使安装了ruby-build,也没有这样的命令“install”

我正在尝试通过rbenv为客户端项目安装ruby 2.1.4 .

虽然之前我已经能够通过rbenv安装ruby版本,但在升级到Yosemite后,我不断收到以下错误:

rbenv: no such command 'install'

在挖掘之后,我看到了很多关于“安装”如何来自ruby-build插件的提示,该插件是通过自制软件安装的:

which ruby-build
/usr/local/bin/ruby-build

我通过Homebrew安装了rbenv,但是当我尝试使用哪个rbenv时,我得到:

rbenv () {
typeset command
command="$1" 
if [ "$#" -gt 0 ]
then
    shift
fi
case "$command" in
    (rehash|shell) eval `rbenv "sh-$command" "$@"` ;;
    (*) command rbenv "$command" "$@" ;;
esac
}

我已经运行了brew update和brew升级rbenv ruby-builder,它告诉我一切都是最新的 .

以下是我的完整$ PATH:

zsh:没有这样的文件或目录:/ usr / local / var / rbenv / shims:/ usr / local / var / rbenv / shims:/ usr / local / bin:/ usr / local / sbin:/ Users / dannycox / . rbenv /垫片:/Users/dannycox/.rbenv/shims:在/ usr / local / bin目录:在/ usr / bin中:/ bin中:/ usr / sbin目录:/ sbin目录中:/ opt / X11 / bin中:在/ usr /本地/去/bin:/Users/dannycox/.rbenv/shims:/Users/dannycox/.rbenv/bin

更新:找到另一个答案,在github上进行更深入的挖掘,显示出有希望的迹象,但未能用rbenv解决问题 . https://github.com/sstephenson/rbenv/issues/610#issuecomment-56240018

我相信2.1.4现在安装在我的机器上,但它安装在这里:成功将ruby 2.1.4安装到/Users/dannycox/.rubies/ruby-2.1.4

因此,我的Bundler将无法使用新的ruby 2.0版本,当我尝试gem install bundle时出现以下错误:

Fetching: bundler-1.7.6.gem (100%)
ERROR:  While executing gem ... (Gem::FilePermissionError)
You don't have write permissions for the /Library/Ruby/Gems/2.0.0 directory

还需要帮助来确定为什么ruby-build与rbenv不相称...

回答(2)

3 years ago

确保在说明中安装可选步骤5:

git clone https://github.com/rbenv/ruby-build.git ~/.rbenv/plugins/ruby-build

安装ruby-build,它提供了rbenv install命令,简化了安装新Ruby版本的过程 .

3 years ago

从您的perms错误我认为您正在尝试安装到系统ruby,这是Apple OSX附带的 . 您想使用rbenv来安装自己的ruby并将gem安装到其中 .

阅读 - https://github.com/rbenv/ruby-build#readme

并使用

rbenv versions

命令显示你将要安装宝石的ruby实例 . 如果它是 system 那么你需要安装自己的ruby实例然后使用ruby作为宝石 .